
/**
 * @(#) MobileAgent.java	1.0 02/09/26
 *
 */


/**
 * @(#)MobileAgent.java	1.0 02/09/26
 *
 * The <code>MobileAgentItf</code> class represents agents that
 * are not mobile.
 * <p>
 *
 * A mobile agent can move to a remote agent server, come back to its home
 * agent server, wait for the arrival of another agent or join another agent.
 * <p>
 *
 * @author Sara Bouchenak
 * @version 1.0, 09/26/02
 * @see     MobileAgentItf
 */

abstract public class MobileAgent
    implements MobileAgentItf {

    /**
     * The name that identifies the agent.
     */
    protected String name;

    /**
     * The host name of the home agent server.
     */
    protected String homeHostName;

    /**
     * The port number of the home agent server.
     */
    protected int homePortNumber;

    /**
     * The host name of the current agent server.
     */
    protected transient String currentHostName;

    /**
     * The port number of the current agent server.
     */
    protected transient int currentPortNumber;

   /**
     * Initializes the agent with a <code>name</code>, and the 
     * <code>host name</code> and the <code>port number</code> of the 
     * agent server on which it is created.
     * <p>
     *
     * @param   name           the name of the agent.
     * @param   homeHostName   the host name of the agent server.
     * @param   homePortNumber the port number of the agent server.
     */
    public void init(String name,
	      String homeHostName,
	      int homePortNumber) {
	//***********************
	// To be completed...
	//***********************
    }

    /**
     * Returns the agent's name.
     *
     * @return  the name of the agent.
     */
    public String getName() {
	//***********************
	// To be completed...
	//***********************
	return null;
    }

    /**
     * Returns the host name of the agent's home agent server.
     *
     * @return  host name of the home agent server.
     */
    public String getHomeHostName() {
	//***********************
	// To be completed...
	//***********************
	return null;
    }

    /**
     * Returns the port number of the agent's home agent server.
     *
     * @return  port number of the home agent server.
     */
    public int getHomePortNumber() {
	//***********************
	// To be completed...
	//***********************
	return 0;
    }

    /**
     * Returns the host name of the agent's current agent server.
     *
     * @return  host name of the current agent server.
     */
    public String getCurrentHostName() {
	//***********************
	// To be completed...
	//***********************
	return null;
    }

    /**
     * Returns the port number of the agent's current agent server.
     *
     * @return  port number of the current agent server.
     */
    public int getCurrentPortNumber() {
	//***********************
	// To be completed...
	//***********************
	return 0;
    }

    /**
     * Sets the value of the Returns the host name of the agent's 
     * current agent server name.
     *
     * @param  hostName name of the current agent server.
     */
    public void setCurrentHostName(String hostName) {
	//***********************
	// To be completed...
	//***********************
    }

    /**
     * Sets the value of the Returns the host name of the agent's 
     * current agent server port.
     *
     * @param  portNumber port number of the current agent server.
     */
    public void setCurrentPortNumber(int portNumber) {
	//***********************
	// To be completed...
	//***********************
    }

    /**
     * Tests if the agent is mobile.
     *
     * @return  TRUE.
     */
    public boolean isMobile() {
	return true;
    }

    /**
     * This is the starting point of the agent; this 
     * method does nothing and returns.
     *<p>
     *
     * Subclasses of <code>StationaryAgent</code> 
     * should override this method.
     */
    public void run() {
    }

    /**
     * The mobile agent moves to an agent server identified by a 
     * <code>name</code> and a <code>port number</code>.
     *
     * @param  hostName  the target agent server's host name.
     * @param  hostPort  the target agent server's port number.
     */
    public void moveTo(String hostName, int hostPort) {
	//***********************
	// To be completed...
	//***********************
    }

    /**
     * The mobile agent comes back to its home agent server.
     *
     */
    public void comeBackHome() {
	//***********************
	// To be completed...
	//***********************
    }

    /**
     * The mobile agent waits for the arrival of another agent identified
     * by a <code>name</code>.
     * The mobile agent blocks until the other agent arrives.
     *
     * @param  otherAgentName  the name of the agent the mobile agent is 
     *                         waiting for.
     */
    public void waitFor(String otherAgentName) {
	//***********************
	// To be completed...
	//***********************
    }

    /**
     * The mobile agent joins another agent identified by a <code>name</code>.
     * The mobile agent moves to the agent server hosting the target agent.
     *
     * @param  otherAgentName  the name of the agent the mobile agent is 
     *                         joining.
     */
    public void meet(String otherAgentName) {
	//***********************
	// To be completed...
	//***********************
    }

}
