
/**
 * @(#) StationaryAgent.java	1.0 02/09/26
 *
 */


/**
 * @(#)StationaryAgent.java	1.0 02/09/26
 *
 * The <code>StationaryAgent</code> class represents agents that
 * are not able to migrate.
 * <p>
 *
 * @author Sara Bouchenak
 * @version 1.0, 09/26/02
 * @see     AgentItf
 */

abstract public class StationaryAgent
    implements AgentItf {

    /**
     * The name that identifies the agent.
     */
    protected String name;

    /**
     * The host name of the home agent server.
     */
    protected String homeHostName;

    /**
     * The port number of the home agent server.
     */
    protected int homePortNumber;

   /**
     * Initializes the agent with a <code>name</code>, and the 
     * <code>host name</code> and the <code>port number</code> of the 
     * agent server on which it is created.
     * <p>
     *
     * @param   name           the name of the agent.
     * @param   homeHostName   the host name of the agent server.
     * @param   homePortNumber the port number of the agent server.
     */
    public void init(String name,
	      String homeHostName,
	      int homePortNumber) {
	//***********************
	// To be completed...
	//***********************
    }

    /**
     * Returns the agent's name.
     *
     * @return  the name of the agent.
     */
    public String getName() {
	//***********************
	// To be completed...
	//***********************
	return null;
    }

    /**
     * Returns the host name of the agent's home agent server.
     *
     * @return  host name of the home agent server.
     */
    public String getHomeHostName() {
	//***********************
	// To be completed...
	//***********************
	return null;
    }

    /**
     * Returns the port number of the agent's home agent server.
     *
     * @return  port number of the home agent server.
     */
    public int getHomePortNumber() {
	//***********************
	// To be completed...
	//***********************
	return 0;
    }

    /**
     * Tests if the agent is mobile.
     *
     * @return  FALSE.
     */
    public boolean isMobile() {
	return false;
    }

    /**
     * This is the starting point of the agent; this 
     * method does nothing and returns.
     *<p>
     *
     * Subclasses of <code>StationaryAgent</code> 
     * should override this method.
     */
    public void run() {
    }

}
